{$R-,G-}

unit support;

{Boring generic support routines, JL20041013.  My old generalfunctions unit of
 17+ years was starting to creep me out (I code a LOT better than I did as a
 teenager) so I decided to start over.  Besides, coding on this 8088 is so
 damn slow that I'll take all the smart linking I can get.}

interface

Function FileExists(filename:String):Boolean;
Function SizeOfFile(filename:string):longint;
Function IntToStr(I:LongInt):String;
Function StrToInt(s:String):LongInt;
Function NumToExt(w:word):string;
Function ReadKeyChar:Char;
Function KeyPressed:Boolean;
Function upstring(name:string):string;
Function EXEsize(fname:string):longint;
Function DiskReady(Drive:char):boolean;
Procedure errorOut(s:string);

implementation

var
  ChkDrvBuf : array[0..512] of byte;  {for drive checking routine}

Function DiskReady(Drive:char):boolean; assembler;
{original code by Brian Pape with mods by G. Davis}
asm
  cmp  drive,'a'
  jb   @isupcase
  sub  drive,20H  { make it UPPER case }
  @isupcase:
  cmp  drive,'Z'
  jb   @driveok
  mov  drive,'A'  { if drive isn't between 'A' and 'Z', make it A) }
  @driveok:
  mov  ax, seg ChkDrvBuf
  mov  es, ax
  mov  bx, offset ChkDrvBuf

  mov  ah, 02  { read disk sectors }
  mov  al, 1   { number of sectors to transfer }
  mov  ch, 1   { track number }
  mov  cl, 1   { sector number }
  mov  dh, 1   { head number }

  mov  dl, drive
  sub  dl, 'A'     { subtract ORD of 'A' }

  int  13h

  mov  bl,true { assume drive is ready }
  and  ah,$80
  jz   @done   { error was something other than disk not ready }
  mov  bl,false{ disk wasn't ready. store result }
  @done:

  mov  ax,$0000  { reset drive }
  INT  13H

  xor  ax,ax   { shut off disk drive quickly }
  mov  es,ax
  mov  ax,440h
  mov  di,ax
  mov  byte ptr es:[di],01h

  mov  al,bl   { retrieve result }
end;  { diskready }

Function EXEsize(fname:string):longint;
Type
  t_size = Record
    mz : Array [1..2] of Char;
    remainder,
    pages : Word;
  end;

Var
  f  : File of t_size;
  sz : t_size;

begin
  assign(f,fname);
  {$i-}
  reset(f);
  {$i+}   { io checking should be off }
  if (ioresult <> 0) then
    exesize:= 0
  else
  begin
    read(f,sz);
    close(f);
    With sz do
      exesize := remainder + (pred(pages) * 512);
  end;
end;

Function upstring(name:string):string;
var
  foo:string;
  loop:byte;
begin
  for loop := 1 to Length(name) do
    foo[loop] := UpCase(name[loop]);
  foo[0]:=name[0];
  upstring:=foo;
end;

Function FileExists(filename:String):Boolean;
Var
  f:File;
Begin
  Assign(f,filename);
  {$I-}
  Reset(f);
  Close(f); {need this or you run out of file handles calling me repeatedly!}
  {$I+}
  FileExists:=(IOResult = 0);
End;

Function SizeOfFile(filename:string):longint;
Var
  f:File;
  foo:LongInt;
Begin
  If fileexists(filename) Then Begin
    Assign(f,filename);
    Reset(f,1);
    foo:=FileSize(f);
    Close(f);
    sizeoffile:=foo;
  End Else SizeOfFile:=-1;
End;

Function IntToStr(I: LongInt): String;
Var
  S: String[11];
Begin
  Str(I, S);
  IntToStr := S;
End;

Function StrToInt(s:String):LongInt;
var
  i:LongInt;
  foo:Integer;
Begin
  Val(S,i,foo);
  strtoint := i;
End;

Function NumToExt(w:word):string;
var
  s:string;
begin
  s:=IntToStr(w);
  if w < 100 then s:='0'+s;
  if w < 10 then s:='0'+s;
  NumToExt:=s;
end;

Procedure errorOut(s:string);
begin
  write(#13#10,'Error: ',s,#13#10);
  halt;
end;

Function KeyPressed:Boolean; Assembler;
Asm
  mov ah, 01h
  int 16h
  mov ax, 00h
  jz @1
  inc ax
  @1:
end;

Function ReadKeyChar:Char; Assembler;
Asm
  mov ah, 00h
  int 16h
end;

end.
